#include <strings.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "common.h"

struct dvb_host *parse(char *urlpart, char *defport)
{
	struct dvb_host *dvbhost;
	char *pos;

	if (!(dvbhost = malloc(sizeof(struct dvb_host)))) {
		perror("malloc");
		exit(EXIT_FAILURE);
	}

	bzero(dvbhost, sizeof(struct dvb_host));
	
	if (!(dvbhost->hostname = strdup(urlpart))) {
		perror("strdup");
		exit(EXIT_FAILURE);
	}

	/* Unneded, but better readablity: */
	dvbhost->location = NULL;
	dvbhost->port = NULL;

	pos = dvbhost->hostname;

	while(*pos != '\0' && *pos != ':' && *pos != '/')
		pos++;

	if (*pos == '/')
		dvbhost->location = pos + 1;

	if (*pos == ':')
		dvbhost->port = pos + 1;

	*pos = 0;

	if (dvbhost->port) {
		pos++;

		while(*pos != '\0' && *pos != '/')
			pos ++;

		if(*pos == '/')
			dvbhost->location = pos + 1;

		*pos = 0;
	}

	if (!dvbhost->port)
		dvbhost->port = strdup(defport);

	if (!dvbhost->location)
		if(!(dvbhost->location = strdup(""))) {
			perror("strdup");
			exit(EXIT_FAILURE);
		}

	return dvbhost;
}
